package org.openapitools.v1_0.api;

import io.swagger.annotations.ApiParam;
import org.openapitools.v1_0.model.Viewer;
import org.openapitools.v1_0.model.UserInfo;
import org.openapitools.v1_0.model.kubernetes.ViewerDeploymentFactory;
import org.openapitools.v1_0.model.kubernetes.ViewerDeploymentFactoryProvider;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.context.request.NativeWebRequest;

import javax.validation.Valid;
import java.util.Iterator;
import java.util.Optional;
import java.util.Arrays;
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2019-10-17T14:06:39.039Z[GMT]")

@Controller
@RequestMapping("${openapi.ePOSNotebook.base-path:/v1.0}")
public class ViewerApiController implements ViewerApi {

    private final NativeWebRequest request;

    @Autowired
    ViewerService viewerService;

    @Autowired
    ViewerDeploymentFactoryProvider factoryProvider;

    @Autowired
    public ViewerApiController(final NativeWebRequest request) {
        this.request = request;
    }

    /**
     * NOTE: if the interface was regenerated by swagger and you get a compiler error
     * about incompatible return type then you need to change ResponseEntity<SomeClass>
     * to ResponseEntity<?> in the interface (ViewerApi.java) and not in this class.
     */
    @Override
    public ResponseEntity<?> createViewer(
        @ApiParam(value = "serviceType of the new viewer service, currently only adaguc and enlighten are supported",required=true) @PathVariable("serviceType") String serviceType,
            @ApiParam(value = "Viewer service")
            @Valid @RequestBody(required=false) Viewer viewer) {
        UserInfo userInfo = null;
        for (Iterator<String> it = request.getHeaderNames(); it.hasNext(); ) {
            String header = it.next();
            if (header.toLowerCase().equals("userinfo")) {
                userInfo = new UserInfo(request.getHeader(header).toString());
            }
        }
        if (viewerService.allowedViewerTypes.equals("")) {
            return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
        }
        if (!Arrays.asList(viewerService.allowedViewerTypes.split(",")).contains(serviceType)) {
            return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
        }
        viewer.setServiceType(serviceType);
        ViewerDeploymentFactory factory = factoryProvider.getFactory(viewer);
        if (null == factory)
            return new ResponseEntity<>(HttpStatus.NOT_FOUND);
        if (null != userInfo) return viewerService.createViewer(viewer, userInfo);
        return viewerService.createViewer(viewer);
    }

    @Override
    public ResponseEntity<?> getViewer(
            @ApiParam(value = "serviceType of the running viewer service, currently only adaguc and enlighten are supported",required=true) @PathVariable("serviceType") String serviceType,
            @ApiParam(value = "Id of the running viewer service.",required=true)
            @PathVariable("id") String viewerId) {
        return viewerService.getViewerById(serviceType, viewerId);
    }

    @Override
    public ResponseEntity<?> deleteViewer(
            @ApiParam(value = "serviceType of the viewer service to be deleted, currently only adaguc and enlighten are supported",required=true) @PathVariable("serviceType") String serviceType,
            @ApiParam(value = "Id of the running viewer service.",required=true)
            @PathVariable("id") String viewerId) {
        return viewerService.deleteViewer(serviceType, viewerId);
    }

    @Override
    public Optional<NativeWebRequest> getRequest() {
        return Optional.ofNullable(request);
    }

}
